package com.realnet.stepperworkflow.Controllers;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.realnet.fnd.response.EntityResponse;
import com.realnet.stepperworkflow.Entity.Stepper_workflow;
import com.realnet.stepperworkflow.Services.Stepper_workflowService;

@RequestMapping(value = "/Stepper_workflow")
@CrossOrigin("*")
@RestController
public class Stepper_workflowController {
	@Autowired
	private Stepper_workflowService Service;

	@Value("${projectPath}")
	private String projectPath;

	@PostMapping("/Stepper_workflow")
	public Stepper_workflow Savedata(@RequestBody Stepper_workflow data) {
		Stepper_workflow save = Service.Savedata(data);

		System.out.println("data saved..." + save);

		return save;
	}

	@PutMapping("/Stepper_workflow/{id}")
	public Stepper_workflow update(@RequestBody Stepper_workflow data, @PathVariable Integer id) {
		Stepper_workflow update = Service.update(data, id);
		System.out.println("data update..." + update);
		return update;
	}

//	get all with pagination
	@GetMapping("/Stepper_workflow/getall/page")
	public Page<Stepper_workflow> getall(@RequestParam(value = "page", required = false) Integer page,
			@RequestParam(value = "size", required = false) Integer size) {
		Pageable paging = PageRequest.of(page, size);
		Page<Stepper_workflow> get = Service.getAllWithPagination(paging);

		return get;

	}

	@GetMapping("/Stepper_workflow")
	public List<Stepper_workflow> getdetails() {
		List<Stepper_workflow> get = Service.getdetails();
		return get;
	}
// get all without authentication 

	@GetMapping("/token/Stepper_workflow")
	public List<Stepper_workflow> getallwioutsec() {
		List<Stepper_workflow> get = Service.getdetails();
		return get;
	}

	@GetMapping("/Stepper_workflow/{id}")
	public Stepper_workflow getdetailsbyId(@PathVariable Integer id) {
		Stepper_workflow get = Service.getdetailsbyId(id);
		return get;
	}

	@DeleteMapping("/Stepper_workflow/{id}")
	public ResponseEntity<?> delete_by_id(@PathVariable Integer id) {
		Service.delete_by_id(id);
		return new ResponseEntity<>(new EntityResponse("Deleted"), HttpStatus.OK);

	}

}